type array t = [ int ] t ;
axiom ( forall < t > el1 , el2 : t :: ( el1 <: el2 ) || ( el2 <: el1 ) ) ;
function is_LT_pivot < t > ( pivot : t , A : array t , left : int , right : int , index : int ) 
	returns ( bool ) 
{
	( forall k : int :: left <= right && left <= k && k < index ==> A [ k ] <: pivot ) }
function is_GT_pivot < t > ( pivot : t , A : array t , left : int , right : int , index : int ) 
	returns ( bool ) 
{
	( forall k : int :: left <= right && index <= k && k <= right ==> pivot <: A [ k ] ) }
axiom ( forall < t > pivot : t , A : array t , left : int , right : int , index : int :: left <= right && is_GT_pivot ( pivot , A , left , right - 1 , index ) && pivot <: A [ right ] ==> is_GT_pivot ( pivot , A , left , right , index ) ) ;
axiom ( forall < t > pivot : t , A : array t , left : int , right : int , index : int :: is_GT_pivot ( pivot , A , left , right , index ) ==> pivot <: A [ index ] ) ;
procedure swap < tt > ( A : array tt , i : int , j : int ) 
	returns ( B : array tt ) 
	ensures ( B [ i ] == A [ j ] && B [ j ] == A [ i ] ) ;

	ensures ( forall k : int :: k != i && k != j ==> B [ k ] == A [ k ] ) ;

{
	var tmp : tt ;
	B := A ;
	tmp := B [ i ] ;
	B [ i ] := B [ j ] ;
	B [ j ] := tmp ;
}
procedure partition < t > ( A : array t , left , right : int , pivot : t ) 
	returns ( index : int , B : array t ) 
	requires left <= right ;

	ensures is_LT_pivot ( pivot , B , left , right , index ) ;

	ensures is_GT_pivot ( pivot , B , left , right , index ) ;

{
	var i : int ;
	B := A ;
	i := left ;
	index := left ;
	while ( i <= right ) 
	invariant ( index <= i ) ;
	invariant is_LT_pivot ( pivot , B , left , i , index ) ; // AUTOMATICALLY GENERATED INVARIANT

	{
		if ( B [ i ] <: pivot ) 
		{
			call B := swap ( B , i , index ) ;
			index := index + 1 ;
		}
		i := i + 1 ;
	}
	
}

