type array t = [ int ] t ;
axiom ( forall < t > el1 , el2 : t :: ( el1 <: el2 ) || ( el2 <: el1 ) ) ;
function is_LT_pivot < t > ( pivot : t , A : array t , left : int , right : int , low : int , high : int ) 
	returns ( bool ) 
{
	( forall k : int :: left <= right && left <= k && k < low ==> A [ k ] <: pivot ) }
function is_GT_pivot < t > ( pivot : t , A : array t , left : int , right : int , low : int , high : int ) 
	returns ( bool ) 
{
	( forall k : int :: left <= right && high < k && k <= right ==> pivot <: A [ k ] ) }
procedure swap < tt > ( A : array tt , i : int , j : int ) 
	returns ( B : array tt ) 
	ensures ( B [ i ] == A [ j ] && B [ j ] == A [ i ] ) ;

	ensures ( forall k : int :: k != i && k != j ==> B [ k ] == A [ k ] ) ;

{
	var tmp : tt ;
	B := A ;
	tmp := B [ i ] ;
	B [ i ] := B [ j ] ;
	B [ j ] := tmp ;
}
procedure partition < t > ( A : array t , left , right : int , pivot : t ) 
	returns ( low_index , high_index : int , B : array t ) 
	requires left <= right ;

	ensures low_index == high_index ;

	ensures is_LT_pivot ( pivot , B , left , right , low_index + 1 , high_index ) ;

	ensures is_GT_pivot ( pivot , B , left , right , low_index , high_index ) ;

{
	var i : int ;
	low_index , high_index := left , right ;
	B := A ;
	while ( low_index != high_index ) 
// 	invariant is_LT_pivot ( pivot , B , low_index - 1 , right , low_index + 1 , high_index ) ; // AUTOMATICALLY GENERATED INVARIANT

	{
		while ( low_index != high_index && B [ low_index ] <: pivot ) 
// 		invariant is_LT_pivot ( pivot , B , low_index - 1 , right , low_index + 1 , high_index ) ; // AUTOMATICALLY GENERATED INVARIANT

		{
			low_index := low_index + 1 ;
		}
		while ( low_index != high_index && pivot <: B [ high_index ] ) 
// 		invariant is_LT_pivot ( pivot , B , low_index - 1 , right , low_index + 1 , high_index ) ; // AUTOMATICALLY GENERATED INVARIANT

		{
			high_index := high_index - 1 ;
		}
		call B := swap ( B , low_index , high_index ) ;
	}
	if ( pivot <: B [ low_index ] ) 
	{
		low_index := low_index - 1 ;
		high_index := low_index ;
	}
	
}

