type array t = [ int ] t ;
axiom ( forall < t > el1 , el2 : t :: ( el1 <: el2 ) || ( el2 <: el1 ) ) ;
function distinct < tt > ( A : array tt , low : int , high : int ) 
	returns ( bool ) 
{
	( forall i , j : int :: low <= i && i <= high && low <= j && j <= high && i != j ==> A [ i ] != A [ j ] ) }
function exists_in < tt > ( v : tt , A : array tt , low : int , high : int ) 
	returns ( bool ) 
{
	( exists j : int :: ( low <= j && j <= high && A [ j ] == v ) ) }
function every_A_in_B < tt > ( A : array tt , B : array tt , low : int , high : int ) 
	returns ( bool ) 
{
	( forall i : int :: ( low <= i && i <= high ==> exists_in ( A [ i ] , B , low , high ) ) ) }
function partitioning_upto < tt > ( A : array tt , low : int , high : int ) 
	returns ( bool ) 
{
	( forall i : int :: low <= i && i <= high ==> A [ i ] <: A [ high ] ) }
procedure swap < ttt > ( A : array ttt , i : int , j : int ) 
	returns ( B : array ttt ) 
	ensures ( B [ i ] == A [ j ] && B [ j ] == A [ i ] ) ;

	ensures ( forall k : int :: k != i && k != j ==> B [ k ] == A [ k ] ) ;

{
	var tmp : ttt ;
	B := A ;
	tmp := B [ i ] ;
	B [ i ] := B [ j ] ;
	B [ j ] := tmp ;
}
procedure bubble_sort < t > ( A : array t , n : int ) 
	returns ( B : array t ) 
	requires n >= 1 ;

	requires distinct ( A , 1 , n ) ;

	ensures distinct ( B , 1 , n ) ;

	ensures partitioning_upto ( B , 1 , n ) ;

{
	var i , j : int ;
	i , j := 1 , 1 ;
	B := A ;
	while ( i < n ) 
// 	invariant distinct ( B , j , n ) ; // AUTOMATICALLY GENERATED INVARIANT

	{
		j := 1 ;
		while ( j <= n - i ) 
// 		invariant distinct ( B , j , n ) ; // AUTOMATICALLY GENERATED INVARIANT

		{
			if ( B [ j + 1 ] <: B [ j ] ) 
			{
				call B := swap ( B , j , j + 1 ) ;
			}
			j := j + 1 ;
		}
		i := i + 1 ;
	}
	
}

