type array t = [ int ] t ;
axiom ( forall < t > el1 , el2 : t :: ( el1 <: el2 ) || ( el2 <: el1 ) ) ;
function count_equals < tt > ( array tt , int , int , array tt , int , int ) 
	returns ( int ) ;
axiom ( forall < tt > A : array tt , B : array tt , lA , hA , lB , hB : int :: hA <= lA ==> count_equals ( A , lA , hA , B , lB , hB ) == 0 ) ;
axiom ( forall < tt > A : array tt , B : array tt , lA , hA , lB , hB : int :: hB <= lB ==> count_equals ( A , lA , hA , B , lB , hB ) == 0 ) ;
axiom ( forall < tt > A : array tt , B : array tt , lA , hA , lB , hB : int :: lA <= hA && lB < hB && A [ hA ] <: B [ hB ] && A [ hA ] != B [ hB ] ==> count_equals ( A , lA , hA , B , lB , hB ) == count_equals ( A , lA , hA + 1 , B , lB , hB ) ) ;
axiom ( forall < tt > A : array tt , B : array tt , lA , hA , lB , hB : int :: lA < hA && lB <= hB && B [ hB ] <: A [ hA ] && A [ hA ] != B [ hB ] ==> count_equals ( A , lA , hA , B , lB , hB ) == count_equals ( A , lA , hA , B , lB , hB + 1 ) ) ;
axiom ( forall < tt > A : array tt , B : array tt , lA , hA , lB , hB : int :: lA <= hA && lB <= hB && A [ hA ] == B [ hB ] ==> count_equals ( A , lA , hA , B , lB , hB ) + 1 == count_equals ( A , lA , hA + 1 , B , lB , hB + 1 ) ) ;
procedure coincidence_count < t > ( A : array t , B : array t , n : int ) 
	returns ( count : int ) 
	requires n >= 0 ;

	ensures count == count_equals ( A , 1 , n + 1 , B , 1 , n + 1 ) ;

{
	var i_A , i_B : int ;
	i_A , i_B , count := 1 , 1 , 0 ;
	while ( i_A <= n && i_B <= n ) 
// 	invariant count == count_equals ( A , 1 , n + count , B , 1 , i_A + 1 ) ; // AUTOMATICALLY GENERATED INVARIANT

	{
		if ( A [ i_A ] <: B [ i_B ] && A [ i_A ] != B [ i_B ] ) 
		{
			i_A := i_A + 1 ;
		}
		else 
		{
			if ( B [ i_B ] <: A [ i_A ] && A [ i_A ] != B [ i_B ] ) 
			{
				i_B := i_B + 1 ;
			}
			else 
			{
				assert ( A [ i_A ] == B [ i_B ] ) ;
				i_A , i_B , count := i_A + 1 , i_B + 1 , count + 1 ;
			}
			
		}
		
	}
	
}

