type array t = [int] t;

function cnt <tt> (x: tt, A: array tt, i: int, j: int) returns (int);
axiom ( forall <tt> x: tt, A: array tt, i: int, j: int ::  i >= 0 && j >= 0  ==>  cnt(x,A,i,j) >= 0 );
axiom ( forall <tt> x: tt, A: array tt, i: int ::  cnt(x,A,i,0) == 0 );
axiom ( forall <tt> x: tt, A: array tt, i: int, j: int ::  i < j  ==>  cnt(x,A,i,j) == 0 );
axiom ( forall <tt> x: tt, A: array tt, i: int, j: int ::  j > 0  &&  j >= i  &&  A[j] == x  ==>  cnt(x,A,i,j+1) == 1 + cnt(x,A,i,j) );
axiom ( forall <tt> x: tt, A: array tt, i: int, j: int ::  j > 0  &&  j >= i  &&  A[j] != x  ==>  cnt(x,A,i,j+1) == cnt(x,A,i,j) );


			
procedure mjrty <t> (A: array t, n: int)
	returns (has_majority: bool, count: int, cand: t)
	requires n > 0;
	ensures  has_majority  ==>  2*cnt(cand, A, 1, n) > n;
	ensures  !has_majority  ==>  (forall c: t  ::  2*cnt(c, A, 1, n) <= n);
{
	var i, k: int;
	
	i, count := 0, 0;

	while ( i < n )
	invariant 0 <= i && i <= n;
	invariant 0 <= count && count <= i;
	// invariant cnt(cand, A, 1, i) >= count;
	// invariant (2*cnt(cand, A, 1, i)) - (2*count) <= i - count;
	// invariant (forall c: t ::  c != cand  ==>  2*cnt(c, A, 1, i) <= i - count);
	{
		i := i + 1;
		if (count == 0)
		{
			count := 1;
			cand := A[i];
		}
		else
		{
			if ( A[i] == cand )
			{
				count := count + 1;
			}
			else
			{
				count := count - 1;
			}
		}
	}

	i, k := 0, 0;
	while ( i < n )
	// for unfathomable reasons, Boogie fails to prove consecution for this invariant
	// BUT, can prove it if another procedure containing this loop alone, is added in the input file!
	// anyway, since this is the uninteresting part of the routine, I just leave this in as free invariant in the tests...
	invariant 0 <= i && i <= n;
	free invariant cnt(cand, A, 1, i) == k;
	{
		i := i + 1;
		if ( A[i] == cand )
		{
			k := k + 1;
		}
	}
	
	if (2*k > n)
	{
		has_majority := true;
	}
	else
	{
		has_majority := false;
	}
}
