type array t = [int] t;

function cnt <tt> (x: tt, A: array tt, i: int, j: int) returns (int);
axiom ( forall <tt> x: tt, A: array tt, i: int, j: int ::  i >= 0 && j >= 0  ==>  cnt(x,A,i,j) >= 0 );
axiom ( forall <tt> x: tt, A: array tt, i: int ::  cnt(x,A,i,0) == 0 );
axiom ( forall <tt> x: tt, A: array tt, i: int, j: int ::  i < j  ==>  cnt(x,A,i,j) == 0 );
axiom ( forall <tt> x: tt, A: array tt, i: int, j: int ::  j > 0  &&  j >= i  &&  A[j] == x  ==>  cnt(x,A,i,j+1) == 1 + cnt(x,A,i,j) );
axiom ( forall <tt> x: tt, A: array tt, i: int, j: int ::  j > 0  &&  j >= i  &&  A[j] != x  ==>  cnt(x,A,i,j+1) == cnt(x,A,i,j) );


			
procedure mjrty <t> (A: array t, n: int)
	returns (count: int, cand: t)
	requires n > 0;
	ensures  (exists c: t  ::  2*cnt(c, A, 1, n) > n) ==> 2*cnt(cand, A, 1, n) > n;
	ensures (forall c: t ::  cnt(c,A,1,n) <= cnt(cand,A,1,n));
{
	var i, k: int;
	
	i, count := 0, 0;

	while ( i < n )
	// invariant 0 <= i && i <= n;
	// invariant 0 <= count && count <= i;
	// invariant cnt(cand, A, 1, i) >= count;
	// invariant (2*cnt(cand, A, 1, i)) - (2*count) <= i - count;
	// invariant (forall c: t ::  c != cand  ==>  2*cnt(c, A, 1, i) <= i - count);
	{
		i := i + 1;
		if (count == 0)
		{
			count := 1;
			cand := A[i];
		}
		else
		{
			if ( A[i] == cand )
			{
				count := count + 1;
			}
			else
			{
				count := count - 1;
			}
		}
	}

}
