type Vertex ;
const Graph : [ Vertex , Vertex ] int ;
axiom ( forall x : Vertex , y : Vertex :: x != y ==> 0 < Graph [ x , y ] ) ;
axiom ( forall x : Vertex , y : Vertex :: x == y ==> Graph [ x , y ] == 0 ) ;
const Infinity : int ;
axiom 0 < Infinity ;
const Source : Vertex ;
var SP : [ Vertex ] int ;
procedure Dijkstra ( ) 
	modifies SP ;

	ensures SP [ Source ] == 0 ;

	ensures ( forall z : Vertex , y : Vertex :: SP [ y ] < Infinity && Graph [ y , z ] < Infinity ==> SP [ z ] <= SP [ y ] + Graph [ y , z ] ) ;

	ensures ( forall z : Vertex :: z != Source && SP [ z ] < Infinity ==> ( exists y : Vertex :: y != z && SP [ z ] == SP [ y ] + Graph [ y , z ] ) ) ;

{
	var v : Vertex ;
	var Visited : [ Vertex ] bool ;
	var oldSP : [ Vertex ] int ;
	havoc SP ;
	assume ( forall x : Vertex :: x == Source ==> SP [ x ] == 0 ) ;
	assume ( forall x : Vertex :: x != Source ==> SP [ x ] == Infinity ) ;
	havoc Visited ;
	assume ( forall x : Vertex :: ! Visited [ x ] ) ;
	while ( ( exists x : Vertex :: ! Visited [ x ] && SP [ x ] < Infinity ) ) 
	invariant ( forall x : Vertex :: SP [ x ] >= 0 ) ;
	invariant ( forall y : Vertex , z : Vertex :: ! Visited [ z ] && Visited [ y ] ==> SP [ y ] <= SP [ z ] ) ;
	invariant ( forall z : Vertex , y : Vertex :: Visited [ y ] && Graph [ y , z ] < Infinity ==> SP [ z ] <= SP [ y ] + Graph [ y , z ] ) ;
	invariant ( forall z : Vertex :: z != Source && SP [ z ] < Infinity ==> ( exists y : Vertex :: y != z && Visited [ y ] && SP [ z ] == SP [ y ] + Graph [ y , z ] ) ) ;
// 	invariant SP [ v ] == 0 ; // AUTOMATICALLY GENERATED INVARIANT

	{
		havoc v ;
		assume ! Visited [ v ] ;
		assume SP [ v ] < Infinity ;
		assume ( forall x : Vertex :: ! Visited [ x ] ==> SP [ v ] <= SP [ x ] ) ;
		Visited [ v ] := true ;
		oldSP := SP ;
		havoc SP ;
		assume ( forall u : Vertex :: Graph [ v , u ] < Infinity && oldSP [ v ] + Graph [ v , u ] < oldSP [ u ] ==> SP [ u ] == oldSP [ v ] + Graph [ v , u ] ) ;
		assume ( forall u : Vertex :: ! ( Graph [ v , u ] < Infinity && oldSP [ v ] + Graph [ v , u ] < oldSP [ u ] ) ==> SP [ u ] == oldSP [ u ] ) ;
	}
	
}

