type array t = [ int ] t ;
type q ;
type Ref ;
const unique s_ref : Ref ;
const unique t_ref : Ref ;
var top : [ Ref ] int ;
var bottom : [ Ref ] int ;
var s : [ Ref ] array q ;
function empty ( low : int , high : int ) 
	returns ( bool ) 
{
	high <= low }
function in_sequence ( v : q , A : array q , low : int , high : int ) 
	returns ( bool ) 
{
	( exists i : int :: low <= i && i <= high && A [ i ] == v ) }
procedure make ( r : Ref ) 
	modifies top , bottom ;

	ensures bottom [ r ] == top [ r ] ;

	ensures empty ( bottom [ r ] , top [ r ] ) ;

	ensures ( forall p : Ref :: p != r ==> old ( bottom ) [ p ] == bottom [ p ] ) ;

	ensures ( forall p : Ref :: p != r ==> old ( top ) [ p ] == top [ p ] ) ;

{
	bottom [ r ] := 0 ;
	top [ r ] := 0 ;
}
procedure empty_p ( r : Ref ) 
	returns ( is_empty : bool ) 
	ensures is_empty <==> empty ( bottom [ r ] , top [ r ] ) ;

{
	is_empty := top [ r ] <= bottom [ r ] ;
}
procedure sequence ( r : Ref ) 
	returns ( a_sequence : array q ) 
	ensures a_sequence == s [ r ] ;

{
	a_sequence := s [ r ] ;
}
procedure top ( r : Ref ) 
	returns ( top_element : q ) 
	requires ! empty ( bottom [ r ] , top [ r ] ) ;

	ensures top_element == s [ r ] [ top [ r ] - 1 ] ;

	ensures in_sequence ( top_element , s [ r ] , bottom [ r ] , top [ r ] - 1 ) ;

{
	top_element := s [ r ] [ top [ r ] - 1 ] ;
}
procedure pop ( r : Ref ) 
	returns ( top_element : q ) 
	modifies top ;

	requires ! empty ( bottom [ r ] , top [ r ] ) ;

	ensures top [ r ] + 1 == old ( top [ r ] ) ;

	ensures s [ r ] [ top [ r ] ] == top_element ;

	ensures ( forall p : Ref :: p != r ==> old ( top ) [ p ] == top [ p ] ) ;

	ensures in_sequence ( top_element , s [ r ] , bottom [ r ] , old ( top ) [ r ] - 1 ) ;

{
	call top_element := top ( r ) ;
	top [ r ] := top [ r ] - 1 ;
}
procedure push ( r : Ref , new_element : q ) 
	modifies top , s ;

	ensures top [ r ] == old ( top [ r ] ) + 1 ;

	ensures s [ r ] [ top [ r ] - 1 ] == new_element ;

	ensures s [ r ] == old ( s ) [ r ] [ old ( top ) [ r ] := new_element ] ;

	ensures ( forall p : Ref :: p != r ==> old ( s ) [ p ] == s [ p ] ) ;

	ensures ( forall p : Ref :: p != r ==> old ( top ) [ p ] == top [ p ] ) ;

	ensures ( forall p : Ref :: p != r ==> old ( s ) [ p ] [ old ( top ) [ p ] ] == s [ p ] [ top [ p ] ] ) ;

{
	s [ r ] [ top [ r ] ] := new_element ;
	top [ r ] := top [ r ] + 1 ;
}
function seq_equal_from_to ( A : array q , B : array q , low_A : int , low_B : int , length : int ) 
	returns ( bool ) ;
axiom ( forall A : array q , B : array q , low_A : int , low_B : int , length : int :: length < 1 ==> seq_equal_from_to ( A , B , low_A , low_B , length ) ) ;
axiom ( forall A : array q , B : array q , low_A : int , low_B : int , length : int :: length >= 1 && A [ low_A + length - 1 ] == B [ low_B + length - 1 ] && seq_equal_from_to ( A , B , low_A , low_B , length - 1 ) ==> seq_equal_from_to ( A , B , low_A , low_B , length ) ) ;
axiom ( forall A : array q , B : array q , low_A : int , low_B : int , length : int :: length >= 1 && A [ low_A + length - 1 ] != B [ low_B + length - 1 ] ==> ! seq_equal_from_to ( A , B , low_A , low_B , length ) ) ;
axiom ( forall A_old : array q , A : array q , B : array q , low_A : int , low_B : int , length : int :: seq_equal_from_to ( A_old , B , low_A , low_B , length ) && ( forall i : int :: low_A <= i && i < low_A + length ==> A [ i ] == A_old [ i ] ) ==> seq_equal_from_to ( A , B , low_A , low_B , length ) ) ;
axiom ( forall A : array q , B : array q , low_A : int , low_B : int , length : int :: A == B && low_A == low_B ==> seq_equal_from_to ( A , B , low_A , low_B , length ) ) ;
function seq_cat_reverse_equals ( A : array q , low_A : int , high_A : int , B : array q , low_B : int , high_B : int , C : array q , low_C : int , high_C : int ) 
	returns ( bool ) ;
axiom ( forall A : array q , low_A : int , high_A : int , B : array q , low_B : int , high_B : int , C : array q , low_C : int , high_C : int :: high_C - low_C != high_A - low_A + high_B - low_B + 1 ==> ! seq_cat_reverse_equals ( A , low_A , high_A , B , low_B , high_B , C , low_C , high_C ) ) ;
axiom ( forall A : array q , low_A : int , high_A : int , B : array q , low_B : int , high_B : int , C : array q , low_C : int , high_C : int :: high_C - low_C == high_A - low_A + high_B - low_B + 1 && high_B < low_B && seq_equal_from_to ( A , C , low_A , low_C , high_C - low_C + 1 ) ==> seq_cat_reverse_equals ( A , low_A , high_A , B , low_B , high_B , C , low_C , high_C ) ) ;
axiom ( forall A : array q , low_A : int , high_A : int , B : array q , low_B : int , high_B : int , C : array q , low_C : int , high_C : int :: high_C - low_C == high_A - low_A + high_B - low_B + 1 && seq_cat_reverse_equals ( A , low_A , high_A , B , low_B , high_B , C , low_C , high_C ) && high_A >= low_A && high_B >= low_B - 1 && A [ high_A ] == B [ high_B + 1 ] ==> seq_cat_reverse_equals ( A , low_A , high_A - 1 , B , low_B , high_B + 1 , C , low_C , high_C ) ) ;
axiom ( forall A : array q , low_A : int , high_A : int , B_old : array q , low_B : int , high_B : int , B : array q , C : array q , low_C : int , high_C : int :: seq_cat_reverse_equals ( A , low_A , high_A , B_old , low_B , high_B , C , low_C , high_C ) && ( forall i : int :: low_B <= i && i <= high_B ==> B [ i ] == B_old [ i ] ) ==> seq_cat_reverse_equals ( A , low_A , high_A , B , low_B , high_B , C , low_C , high_C ) ) ;
axiom ( forall A : array q , low_A : int , high_A : int , B : array q , low_B : int , high_B : int , B_old : array q , C : array q , low_C : int , high_C : int :: seq_cat_reverse_equals ( A , low_A , high_A , B_old , low_B , high_B , C , low_C , high_C ) && ( forall i : int :: low_B <= i && i <= high_B ==> B [ i ] == B_old [ i ] ) && B [ high_B + 1 ] == A [ high_A ] ==> seq_cat_reverse_equals ( A , low_A , high_A - 1 , B , low_B , high_B + 1 , C , low_C , high_C ) ) ;
axiom ( forall A : array q , low_A : int , high_A : int , A_old : array q , B : array q , low_B : int , high_B : int , C : array q , low_C : int , high_C : int :: seq_cat_reverse_equals ( A_old , low_A , high_A , B , low_B , high_B , C , low_C , high_C ) && ( forall i : int :: low_A <= i && i <= high_A ==> A [ i ] == A_old [ i ] ) && A [ high_A + 1 ] == B [ high_B ] ==> seq_cat_reverse_equals ( A , low_A , high_A + 1 , B , low_B , high_B - 1 , C , low_C , high_C ) ) ;
procedure stack_lookup_nondestructive ( v : q ) 
	returns ( found : bool ) 
	modifies s , top , bottom ;

	requires ! empty ( bottom [ s_ref ] , top [ s_ref ] ) ;

	ensures ( top [ t_ref ] - bottom [ t_ref ] == 0 ) ;

	ensures ( top [ s_ref ] - bottom [ s_ref ] + top [ t_ref ] - bottom [ t_ref ] == old ( top ) [ s_ref ] - old ( bottom ) [ s_ref ] ) ;

	ensures ( seq_cat_reverse_equals ( s [ s_ref ] , bottom [ s_ref ] , top [ s_ref ] - 1 , s [ t_ref ] , bottom [ t_ref ] , top [ t_ref ] - 1 , old ( s ) [ s_ref ] , old ( bottom ) [ s_ref ] , old ( top ) [ s_ref ] - 1 ) ) ;

	ensures ( ! found ==> ! in_sequence ( v , s [ t_ref ] , bottom [ t_ref ] , top [ t_ref ] - 1 ) ) ;

	ensures ( found ==> in_sequence ( v , old ( s ) [ s_ref ] , old ( bottom ) [ s_ref ] , old ( top ) [ s_ref ] - 1 ) ) ;

{
	var cv : q ;
	call make ( t_ref ) ;
	found := false ;
	while ( ! empty ( bottom [ s_ref ] , top [ s_ref ] ) && ! found ) 
// 	invariant ( ! found ==> ! in_sequence ( cv , s [ t_ref ] , bottom [ t_ref ] , top [ t_ref ] - 1 ) ) ; // AUTOMATICALLY GENERATED INVARIANT

	{
		call cv := pop ( s_ref ) ;
		call push ( t_ref , cv ) ;
		if ( cv == v ) 
		{
			found := true ;
		}
		
	}
	while ( ! empty ( bottom [ t_ref ] , top [ t_ref ] ) ) 
// 	invariant ( ! found ==> ! in_sequence ( cv , s [ t_ref ] , bottom [ t_ref ] , top [ t_ref ] - 1 ) ) ; // AUTOMATICALLY GENERATED INVARIANT

	{
		call cv := pop ( t_ref ) ;
		call push ( s_ref , cv ) ;
	}
	
}
procedure check_assertion ( v : q ) 
	modifies s , top , bottom ;

	requires ! empty ( bottom [ s_ref ] , top [ s_ref ] ) ;

	ensures true ;

{
	var found : bool ;
	var cv : q ;
	assume ( found ==> in_sequence ( v , old ( s ) [ s_ref ] , old ( bottom ) [ s_ref ] , old ( top ) [ s_ref ] - 1 ) ) ;
	assume ( ! found ==> ! in_sequence ( v , s [ t_ref ] , bottom [ t_ref ] , top [ t_ref ] - 1 ) ) ;
	assume ( top [ s_ref ] - bottom [ s_ref ] + top [ t_ref ] - bottom [ t_ref ] == old ( top ) [ s_ref ] - old ( bottom ) [ s_ref ] ) ;
	assume ( seq_cat_reverse_equals ( s [ s_ref ] , bottom [ s_ref ] , top [ s_ref ] - 1 , s [ t_ref ] , bottom [ t_ref ] , top [ t_ref ] - 1 , old ( s ) [ s_ref ] , old ( bottom ) [ s_ref ] , old ( top ) [ s_ref ] - 1 ) ) ;
	assume ( empty ( bottom [ s_ref ] , top [ s_ref ] ) || found ) ;
	assert ( ! found ==> ! in_sequence ( v , old ( s ) [ s_ref ] , old ( bottom ) [ s_ref ] , old ( top ) [ s_ref ] - 1 ) ) ;
}
procedure check_consecution ( v : q ) 
	modifies s , top , bottom ;

	requires ! empty ( bottom [ s_ref ] , top [ s_ref ] ) ;

	ensures true ;

{
	var found : bool ;
	var cv : q ;
	assume ( found ==> in_sequence ( v , old ( s ) [ s_ref ] , old ( bottom ) [ s_ref ] , old ( top ) [ s_ref ] - 1 ) ) ;
	assume ( ! found ==> ! in_sequence ( v , s [ t_ref ] , bottom [ t_ref ] , top [ t_ref ] - 1 ) ) ;
	assume ( top [ s_ref ] - bottom [ s_ref ] + top [ t_ref ] - bottom [ t_ref ] == old ( top ) [ s_ref ] - old ( bottom ) [ s_ref ] ) ;
	assume ( seq_cat_reverse_equals ( s [ s_ref ] , bottom [ s_ref ] , top [ s_ref ] - 1 , s [ t_ref ] , bottom [ t_ref ] , top [ t_ref ] - 1 , old ( s ) [ s_ref ] , old ( bottom ) [ s_ref ] , old ( top ) [ s_ref ] - 1 ) ) ;
	assume ( empty ( bottom [ s_ref ] , top [ s_ref ] ) || found ) ;
	call cv := pop ( s_ref ) ;
	call push ( t_ref , cv ) ;
	if ( cv == v ) 
	{
		found := true ;
	}
	assert ( found ==> in_sequence ( v , old ( s ) [ s_ref ] , old ( bottom ) [ s_ref ] , old ( top ) [ s_ref ] - 1 ) ) ;
}

