function compatible_sort ( Graph : [ int , int ] bool , S : [ int ] int , n : int ) 
	returns ( bool ) ;
axiom ( forall Graph : [ int , int ] bool , S : [ int ] int , n : int :: n == 0 ==> compatible_sort ( Graph , S , n ) ) ;
axiom ( forall Graph : [ int , int ] bool , S : [ int ] int , n : int :: n > 0 && compatible_sort ( Graph , S , n - 1 ) && ( forall a : int :: Graph [ a , S [ n ] ] ==> ( exists b : int :: 1 <= b && b < n && S [ b ] == a ) ) ==> compatible_sort ( Graph , S , n ) ) ;
axiom ( forall Graph : [ int , int ] bool , S : [ int ] int , T : [ int ] int , n : int :: n > 0 && compatible_sort ( Graph , T , n ) && ( forall i : int :: 1 <= i && i <= n ==> T [ i ] == S [ i ] ) ==> compatible_sort ( Graph , S , n ) ) ;
procedure topo_sort ( DAG : [ int , int ] bool , E : [ int ] bool ) 
	returns ( S : [ int ] int , n : int ) 
	ensures ( forall i : int :: 1 <= i && i <= n ==> E [ S [ i ] ] ) ;

	ensures ( forall i : int :: E [ i ] ==> ( exists j : int :: 1 <= j && j <= n && S [ j ] == i ) ) ;

	ensures ( compatible_sort ( DAG , S , n ) ) ;

{
	var x : int ;
	var G , H : [ int , int ] bool ;
	var elements : [ int ] bool ;
	var exit_now : bool ;
	G := DAG ;
	elements := E ;
	n := 0 ;
	while ( ( exists i : int :: elements [ i ] ) ) 
	invariant ( forall i : int :: elements [ i ] ==> E [ i ] ) ;
	invariant ( forall a : int , b : int :: G [ a , b ] ==> DAG [ a , b ] ) ;
	invariant ( forall a : int , b : int :: DAG [ a , b ] && ! G [ a , b ] ==> ( exists c : int :: 1 <= c && c <= n && S [ c ] == a ) ) ;
	invariant ( n > 0 ==> ( forall a : int :: DAG [ a , S [ n ] ] ==> ( exists b : int :: 1 <= b && b < n && S [ b ] == a ) ) ) ;
// 	invariant ( forall i : int :: x <= i && i <= n ==> E [ S [ i ] ] ) ; // AUTOMATICALLY GENERATED INVARIANT

	{
		havoc x ;
		assume ( forall a : int :: ! G [ a , x ] ) ;
		assume ( elements [ x ] ) ;
		n := n + 1 ;
		S [ n ] := x ;
		elements [ x ] := false ;
		havoc H ;
		assume ( forall b : int :: ! H [ x , b ] ) ;
		assume ( forall a : int , b : int :: H [ a , b ] ==> G [ a , b ] ) ;
		assume ( forall a : int , b : int :: x != a && G [ a , b ] ==> H [ a , b ] ) ;
		G := H ;
	}
	
}

